import { Ref, InjectionKey } from 'vue-demi';
export declare type ConditionsType = {
    [propName: string]: any;
};
export declare type FetcherType = (params: ConditionsType) => Promise<any>;
export declare type ProvideKeyName<T> = InjectionKey<T> | string;
export interface QueryOptions<T> {
    sync?: ProvideKeyName<T>;
    ignore?: string[];
}
export interface Config {
    fetcher: FetcherType;
    conditions: ConditionsType;
    defaultParams?: ConditionsType;
    beforeFetch?: (conditions: ConditionsType) => ConditionsType;
}
export interface ResultInterface {
    conditions: {
        [x: string]: any;
    };
    loading: Ref<boolean | false>;
    data: Ref<any | null>;
    refresh: Ref<() => void>;
    error: Ref<any | null>;
}
